__all__ = 'ApplicationAttributeNotFound'

from .plugin_error import PluginError


class ApplicationAttributeNotFound(PluginError):
    def __init__(self, app: str, app_version: str, key: str):
        error_msg = "Could not find attribute '" + str(key) + "' for app '" + str(app) + " (" + str(app_version) + ")'"
        PluginError.__init__(self, error_msg)
