__all__ = 'ProjectRequiresSavingError'

from .plugin_error import PluginError

import typing

if typing.TYPE_CHECKING:
    from submit2gm.packed_project import PackedProject
    from submit2gm.dynamic_job_preset import DynamicJobPreset
    from submit2gm.widgets.node_editor.node_widget import DependencyNode


class ProjectRequiresSavingError(PluginError):

    def __init__(self,
                 get_current_scene: typing.Callable[[], typing.Tuple['PackedProject',
                                                                     typing.List['DynamicJobPreset'],
                                                                     typing.Dict[str, 'DependencyNode']]],
                 message: str):

        PluginError.__init__(self, message)
        self._get_current_scene = get_current_scene

    def get_current_scene_cb(self) -> typing.Callable[[], typing.Tuple['PackedProject',
                                                                       typing.List['DynamicJobPreset'],
                                                                       typing.Dict[str, 'DependencyNode']]]:
        return self._get_current_scene
