__all__ = 'ExceptionWrapper'

import traceback


class ExceptionWrapper:

    def __init__(self, exception: Exception, exc_type, exc_value, exc_tb):
        self._exception = exception
        self._exc_type = exc_type
        self._exc_value = exc_value
        self._exc_tb = exc_tb

    def get_exception(self) -> Exception:
        return self._exception

    def to_string(self) -> str:
        traceback_lines = traceback.format_exception(self._exc_type, self._exc_value, self._exc_tb)
        traceback_string = u'\n'.join(traceback_lines)

        try:
            exception_string = str(self._exc_value)
        except TypeError:
            exception_string = "None string error message"

        return "{}\n{}".format(exception_string, traceback_string)
