__all__ = 'LocalProject'

from abc import abstractmethod
import pathlib
import typing

from .project import Project


class LocalProject(Project):

    def __init__(self,
                 name: str,
                 root_dir: pathlib.Path,
                 files: typing.Set[pathlib.Path],
                 attributes: typing.Dict):

        Project.__init__(self,
                         name,
                         root_dir,
                         files,
                         attributes)

    @abstractmethod
    def exists(self) -> bool:
        raise NotImplementedError

    @abstractmethod
    def delete(self) -> None:
        raise NotImplementedError

    def get_size(self) -> int:
        project_size = 0
        for file in self.get_files():
            project_size += file.stat().st_size
        return project_size
