__all__ = 'PluginAccessor'

import typing

if typing.TYPE_CHECKING:
    from submit2gm.submit2gm_plugin import Submit2gmPlugin


class PluginAccessor:
    """
    Any subclass of this class has direct access to the plugin instance.
    """

    def __init__(self, plugin: 'Submit2gmPlugin'):
        self._plugin = plugin

    def get_plugin(self) -> 'Submit2gmPlugin':
        return self._plugin
