__all__ = 'PluginFetcher'

import typing

if typing.TYPE_CHECKING:
    from submit2gm.submit2gm_plugin import Submit2gmPlugin


class PluginFetcher:

    _plugin = None

    @staticmethod
    def get_plugin() -> 'Submit2gmPlugin':
        from submit2gm.submit2gm_plugin import Submit2gmPlugin

        if PluginFetcher._plugin is None:
            PluginFetcher._plugin = Submit2gmPlugin()

        return PluginFetcher._plugin

    @staticmethod
    def get_plugin_if_initialised() -> typing.Optional['Submit2gmPlugin']:

        if PluginFetcher._plugin is None:
            return None

        return PluginFetcher._plugin

    @staticmethod
    def delete_cached_plugin() -> None:
        if PluginFetcher._plugin:
            PluginFetcher._plugin = None
