__all__ = 'PluginVersion'

import typing


class PluginVersion:

    def __init__(self, major: int, minor: int, build: int):
        self._major = major
        self._minor = minor
        self._build = build

    def get_major_version(self) -> int:
        return self._major

    def get_minor_version(self) -> int:
        return self._minor

    def get_build_version(self) -> int:
        return self._build

    def get_as_tuple(self) -> typing.Tuple[int, int, int]:
        return self.get_major_version(), self.get_minor_version(), self.get_build_version()

    def to_string(self) -> str:
        return str(self._major) + '.' + str(self._minor) + '.' + str(self._build)
