__all__ = 'Product'


class Product:

    def __init__(self, unique_id: int, display_name: str, app_type: str, version: str):
        """
        :param unique_id: A unique integer that specifies this product
        :type unique_id: int
        :param display_name: The name of the product to use when displaying to the user
        :type display_name: str
        :param app_type: The application this product represents
        :type app_type: str
        :param version: The version of the application
        :type version: str
        """

        self._unique_id = unique_id
        self._display_name = display_name
        self._app_type = app_type
        self._version = version

    def get_unique_id(self) -> int:
        return self._unique_id

    def get_app_type(self) -> str:
        return self._app_type

    def get_display_name(self) -> str:
        return self._display_name

    def get_version(self) -> str:
        return self._version
