__all__ = 'SceneExporter'

from abc import abstractmethod
import pathlib
import typing

from .plugin_accessor import PluginAccessor

if typing.TYPE_CHECKING:
    from .submit2gm_plugin import Submit2gmPlugin


class SceneExporter(PluginAccessor):

    def __init__(self, plugin: 'Submit2gmPlugin'):
        PluginAccessor.__init__(self, plugin)

    @abstractmethod
    def export(self, output_dir: pathlib.Path) -> pathlib.Path:
        raise NotImplementedError
