__all__ = 'VrayJobPresetValidator'

import typing

from submit2gm import constants
from submit2gm.job_preset_validator import JobPresetValidator


if typing.TYPE_CHECKING:
    from submit2gm.dynamic_job_preset import DynamicJobPreset


class VrayJobPresetValidator(JobPresetValidator):

    def validate(self, job_preset: 'DynamicJobPreset') -> typing.Tuple[bool, str]:
        is_valid = True
        validation_message = u""

        output_prefix = job_preset.get_job_preset_attribute_by_key(constants.API_KEYS.OUTPUT_PREFIX).eval()
        if not output_prefix:
            return False, "No output prefix set, you must provide an output prefix when using V-Ray standalone."

        return is_valid, validation_message
