__all__ = 'UserInfo'

import typing


class UserInfo:

    def __init__(self,
                 business_verticals: typing.List[str],
                 created: str,
                 credits_available: float,
                 credits_consumed: float,
                 email_address: str,
                 job_throughput_limit: int,
                 max_throughput: int,
                 name: str,
                 plugin_versions: typing.Dict,
                 service_plan: str,
                 username: str):

        self._business_verticals = business_verticals
        self._created = created
        self._credits_available = credits_available
        self._credits_consumed = credits_consumed
        self._email_address = email_address
        self._job_throughput_limit = job_throughput_limit
        self._max_throughput = max_throughput
        self._name = name
        self._plugin_versions = plugin_versions
        self._service_plan = service_plan
        self._username = username

    def get_business_verticals(self) -> typing.List[str]:
        return self._business_verticals

    def get_created(self) -> str:
        return self._created

    def get_credits_available(self) -> float:
        return self._credits_available

    def get_credits_consumed(self) -> float:
        return self._credits_consumed

    def get_email_address(self) -> str:
        return self._email_address

    def get_job_throughout_limit(self) -> int:
        return self._job_throughput_limit

    def get_max_throughout(self) -> int:
        return self._max_throughput

    def get_name(self) -> str:
        return self._name

    def get_plugin_versions(self) -> typing.Dict:
        return self._plugin_versions

    def get_service_plan(self) -> str:
        return self._service_plan

    def get_username(self) -> str:
        return self._username

    def serialise(self) -> typing.Dict:
        return {
            "business_verticals": self.get_business_verticals(),
            "created": self.get_created(),
            "credits_available": self.get_credits_available(),
            "credits_consumed": self.get_credits_consumed(),
            "email_address": self.get_email_address(),
            "job_throughput_limit": self.get_job_throughout_limit(),
            "max_throughput": self.get_max_throughout(),
            "name": self.get_name(),
            "plugin_versions": self.get_plugin_versions(),
            "service_plan": self.get_service_plan(),
            "username": self.get_username()
        }
