__all__ = 'CheckBox'

from PySide2 import QtWidgets
from PySide2 import QtCore
import typing

from submit2gm.widgets.input_widgets.input_widget import InputWidget

if typing.TYPE_CHECKING:
    from submit2gm.submit2gm_plugin import Submit2gmPlugin


class CheckBox(QtWidgets.QCheckBox, InputWidget):

    def __init__(self, plugin: 'Submit2gmPlugin', parent: typing.Optional['QtWidgets.QWidget'] = None):
        QtWidgets.QCheckBox.__init__(self, parent=parent)
        InputWidget.__init__(self, plugin)

        self.setFocusPolicy(QtCore.Qt.StrongFocus)
        self.stateChanged.connect(self._catch_value_change)

    def get_value(self) -> bool:
        return self.checkState() == QtCore.Qt.Checked

    def set_value(self, value: bool) -> None:
        if value:
            self.setCheckState(QtCore.Qt.Checked)
        else:
            self.setCheckState(QtCore.Qt.Unchecked)