__all__ = 'ComboBox'

from PySide2 import QtCore
from PySide2 import QtGui
from PySide2 import QtWidgets
import typing

from submit2gm.widgets.input_widgets.input_widget import InputWidget

if typing.TYPE_CHECKING:
    from submit2gm.submit2gm_plugin import Submit2gmPlugin


class Constant(QtWidgets.QLineEdit, InputWidget):

    clicked = QtCore.Signal()
    doubleClicked = QtCore.Signal()

    def __init__(self, plugin: 'Submit2gmPlugin', value: str, parent: typing.Optional['QtWidgets.QWidget'] = None):
        QtWidgets.QLineEdit.__init__(self, str(value), parent=parent)
        InputWidget.__init__(self, plugin)
        self.setReadOnly(True)

    def mouseReleaseEvent(self, event: QtGui.QMouseEvent) -> None:
        self.clicked.emit()

    def mouseDoubleClickEvent(self, event: QtGui.QMouseEvent) -> None:
        self.doubleClicked.emit()

    def get_value(self) -> str:
        return self.text()

    def set_value(self, value: str) -> None:
        self.setText(value)
