__all__ = 'InputWidget'

from PySide2 import QtCore
from submit2gm.plugin_accessor import PluginAccessor


class InputWidget(PluginAccessor):

    # all input widgets must have a signal for when their value has been changed
    input_value_changed = QtCore.Signal()

    def get_value(self) -> any:
        raise NotImplementedError

    def set_value(self, value: any) -> None:
        raise NotImplementedError

    def _catch_value_change(self) -> None:
        self.input_value_changed.emit()
