__all__ = ['Notification']

from PySide2 import QtWidgets
import typing

from .elided_label import ElidedLabel
from submit2gm import constants


class Notification(QtWidgets.QGroupBox):

    def __init__(self, text: str, parent: typing.Optional['QtWidgets.QWidget'] = None):
        QtWidgets.QGroupBox.__init__(self, parent=parent)

        self.autoFillBackground = True
        self.setProperty(constants.STYLE_PROPS.NOTIFICATION_INFO, True)

        """ Create Widgets """
        self._label = ElidedLabel(text)
        self._label.setProperty(constants.STYLE_PROPS.H4_5, True)
        self._close_btn = QtWidgets.QPushButton('X')
        self._close_btn.setFlat(True)
        self._close_btn.setSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)

        """ Create Layouts """
        self._layout = QtWidgets.QHBoxLayout(self)
        self._layout.addWidget(self._label)
        self._layout.addWidget(self._close_btn)

        """ Create Connections """
        self._close_btn.clicked.connect(self.hide)
