__all__ = 'ResizableStackedWidget'

from PySide2 import QtCore
from PySide2 import QtWidgets


class ResizableStackedWidget(QtWidgets.QStackedWidget):
    """
    A QStackedWidget which resizes to its current widget instead of taking the size of it's largest widget(s)
    """

    def sizeHint(self) -> 'QtCore.QSize':
        if self.currentWidget():
            return self.currentWidget().sizeHint()
        return QtCore.QSize(0,0)

    def minimumSizeHint(self) -> 'QtCore.QSize':
        if self.currentWidget():
            return self.currentWidget().minimumSizeHint()
        return QtCore.QSize(0, 0)
