from PySide2 import QtWidgets
import typing

if typing.TYPE_CHECKING:
    from PySide2 import QtGui


class RightAlignedQMenu(QtWidgets.QMenu):

    def __init__(self, label: str, parent: typing.Optional[QtWidgets.QWidget]):
        QtWidgets.QMenu.__init__(self, label, parent=parent)
        self.setMinimumWidth(parent.minimumWidth())

    def showEvent(self, event: 'QtGui.QShowEvent') -> None:
        # Align the QMenu to the right of its parent
        p = self.pos()
        geo = self.parent().geometry()
        self.move(p.x() + geo.width() - self.geometry().width(), p.y())
