__all__ = 'PluginError'

import sys
import traceback


class PluginError(Exception):

    def __init__(self, message = None):
        Exception.__init__(self, message)

        if not isinstance(message, str):
            message = str(message)

        self._message = message

        try:
            self.traceback = traceback.extract_tb(sys.exc_info()[2])

        except AttributeError:
            self.traceback = None
            pass

    def __str__(self):
        msg = self._message or '<empty message>'
        return msg

    @property
    def user_message(self):
        return self._message

    def __repr__(self):

        class_name = self.__class__.__name__
        msg = self._message or '<empty message>'

        return "%s(message=%r)" % (class_name, msg)
