__all__ = 'ProjectRequiresSavingError'

from gm_meta_plugin.errors.plugin_error import PluginError

import typing

if typing.TYPE_CHECKING:
    from gm_meta_plugin.packed_project import PackedProject
    from gm_meta_plugin.dynamic_job_preset import DynamicJobPreset


class ProjectRequiresSavingError(PluginError):

    def __init__(self, get_current_scene: typing.Callable[[], typing.Tuple['PackedProject', 'DynamicJobPreset']], message: str = None):
        PluginError.__init__(self, message)
        self._get_current_scene = get_current_scene

    def get_current_scene_cb(self) -> typing.Callable[[],  typing.Tuple['PackedProject', 'DynamicJobPreset']]:
        return self._get_current_scene
