__all__ = 'ExcThread'

import threading


class ExcThread(threading.Thread):
    """
    A Threading class which captures exceptions as well as return values and stores them in a queue
    """

    def __init__(self, bucket, target, args = None, kwargs = None):
        threading.Thread.__init__(self)
        self.bucket = bucket
        self._target = target
        self._args = args if args else ()
        self._kwargs = kwargs if kwargs else {}

    def run(self):
        try:
            result = self._target(*self._args, **self._kwargs)
            self.bucket.put(result)
        except Exception as e:
            self.bucket.put(e)
