__all__ = 'APISchema'

from . import constants as api_constants
import gm_meta_plugin
from gm_meta_plugin.api_schema import APISchema as MetaAPISchema


class APISchema(MetaAPISchema):

    def __init__(self,
                 plugin,
                 job_definitions,
                 project_definition_schema):

        MetaAPISchema.__init__(self, plugin, job_definitions, project_definition_schema)

    def trim_unsupported_applications(self, plugin):

        for job_definition in self.get_job_definitions():
            app_attribute = job_definition.get_attribute_with_id(api_constants.API_KEYS.APP)

            if app_attribute:
                default_value = app_attribute.get_attribute().get_default_value()

                if default_value not in plugin.get_supported_applications():
                    # remove application inference sources from all job attributes
                    for job_attribute in job_definition.get_attributes():
                        inference_sources = job_attribute.get_inference_sources()

                        if gm_meta_plugin.InferenceSource.get_application_inference_source() in inference_sources:
                            inference_sources.remove(gm_meta_plugin.InferenceSource.get_application_inference_source())

                        job_attribute.set_inference_sources(inference_sources)
