COMPANY_NAME = u"GridMarkets"
ROOT_ATTRIBUTE_ID = "GM_PROJECT_NAME"

ENUM_SUBTYPE_PRODUCT_VERSIONS = "PRODUCT_VERSIONS"
BLENDER_VERSIONS_ENUM_ID = "BLENDER_VERSION"

"""
BLENDER_2_80_MAIN_PROJECT_FILE = "BLENDER_2_80_MAIN_PROJECT_FILE"
BLENDER_2_80_RENDER_ENGINE = "BLENDER_2_80_RENDER_ENGINE"
BLENDER_2_79_MAIN_PROJECT_FILE = "BLENDER_2_79_MAIN_PROJECT_FILE"
BLENDER_2_79_RENDER_ENGINE = "BLENDER_2_79_RENDER_ENGINE"
"""

EXTERNAL_FILES_DIR_NAME = "gm_external_files"

class PROJECT_ATTRIBUTE_IDS:
    PROJECT_NAME = ROOT_ATTRIBUTE_ID
    PRODUCT = "PRODUCT"
    PRODUCT_VERSION = "PRODUCT_VERSION"
    BLENDER_VERSION = "BLENDER_VERSION"
    VRAY_VERSION = "VRAY_VERSION"
    MAYA_VERSION = "MAYA_VERSION"
    NUKE_VERSION = "NUKE_VERSION"


class PROJECT_TYPE_IDS:
    BLENDER_2_8X_CYCLES_PROJECT = "BLENDER_2_8X_CYCLES_PROJECT"
    C4D_PROJECT = "C4D_PROJECT"
    MAYA_PROJECT = "MAYA_PROJECT"
    MAX_PROJECT = "MAX_PROJECT"
    NUKE_PROJECT = "NUKE_PROJECT"


class JOB_DEFINITION_IDS:
    BLENDER_2_8X_CYCLES = 'BLENDER_2_8X_CYCLES'
    MAYA = 'MAYA'
    MAX = 'MAX'
    NUKE = 'NUKE'


class API_KEYS:
    IS_SAVED = "is_saved"
    PROJECT_NAME = "project_name"
    SUBMISSION_NAME = "submission_name"
    SUBMISSION_COMMENT = "submission_comment"
    JOB_NAME = "name"
    APP = "app"
    APP_VERSION = "app_version"
    OPERATION = "operation"
    PLUGINS = "plugins"
    CREDITS_BUDGET = "credits_budget"
    CREDITS_BUDGET_ACTION = "credits_budget_action"
    PATH = "path"
    FRAMES = "frames"
    OUTPUT_PATH = "output_path"
    OUTPUT_PREFIX = "output_prefix"
    OUTPUT_FORMAT = "output_format"
    OUTPUT_MULTIPASS_PREFIX = "output_multipass_prefix"
    OUTPUT_MULTIPASS_FORMAT = "output_multipass_format"
    RENDER_ENGINE = "engine"
    RENDERER = "renderer"
    CAMERA = "camera"
    OUTPUT_WIDTH = "output_width"
    OUTPUT_HEIGHT = "output_height"
    SCENE_FILE_PATH_UNUSED = "scene_file_path_unused"
    GPU = "gpu"
    MACHINE_TYPE = "machine_type"
    INSTANCES = "instances"
    PROJECT_TYPE_ID = "project_type_id"
    REMAP = "remap"
    IN_GAMMA = "input_gamma"
    OUT_GAMMA = "output_gamma"
    USE_VRAY_STANDALONE = "use_vray_standalone"
    RENDER_LAYERS = "render_layers"
    TAKE = "take"
    TAKES = "takes"


# The python envoy client treats these attributes as something other than job parameters so we always skip them as they
# are dealt with elsewhere.
ALWAYS_SKIPPED_API_KEYS = [
    API_KEYS.IS_SAVED,
    API_KEYS.SUBMISSION_NAME,
    API_KEYS.SUBMISSION_COMMENT,
    API_KEYS.CREDITS_BUDGET,
    API_KEYS.CREDITS_BUDGET_ACTION
]


class SUBTYPE_KEYS:
    class STRING:
        class PATH:
            FILE_MODE = "FILE_MODE"
            FILE_PATH = "FILE_PATH"
            DIR_PATH = "DIR_PATH"

    class ENUM:
        class PRODUCT_VERSIONS:
            PRODUCT = "PRODUCT"
            MATCH = "MATCH"

        class MACHINE_TYPE:
            PRODUCT = "PRODUCT"
            OPERATION = "OPERATION"
            USE_GPU_DEFAULT = "USE_GPU_DEFAULT"

class JOB_ACTIONS:
    CREDITS_BUDGET_ACTION_ALERT = "CREDITS_BUDGET_ACTION_ALERT"
    CREDITS_BUDGET_ACTION_STOP = "CREDITS_BUDGET_ACTION_STOP"
    CREDITS_BUDGET_ACTION_SUSPEND = "CREDITS_BUDGET_ACTION_SUSPEND"


class PRODUCTS:
    BLENDER = u"blender"
    C4D = u"c4d"
    VRAY = u"vray"
    MOE = u"moe"
    MAYA = u"maya"
    MAX = u"3ds"
    NUKE = u"nuke"


class PLUGINS:
    ARNOLD = "arnold"
    REDSHIFT = "redshift"
    VRAY = "vray"


class OPERATION_TYPES:
    RENDER = u"render"


class BLENDER_VERSIONS:
    V_2_81A = "2.81a"
    V_2_80 = "2.80"
    V_2_79B = "2.79b"
    SERIES_2_8X = "^([2]\\.)([1-7]\\d)"
    SERIES_2_7X = "^([2]\\.)([8]\\d)"


class BLENDER_ENGINES:
    CYCLES = "CYCLES"
    EEVEE = "EEVEE"
    INTERNAL = "INTERNAL"


class VRAY_VERSIONS:
    V_3_60_03 = "3.60.03"
    V_3_60_04 = "3.60.04"
    V_3_60_05 = "3.60.05"
    V_4_02_05 = "4.02.05"
    V_4_10_01 = "4.10.01"
    V_4_10_02 = "4.10.02"


class ATTRIBUTE_NAMES:
    PRODUCT = "app"
