__all__ = 'Product'


class Product:

    def __init__(self, unique_id, display_name, app_type, version):
        """
        :param unique_id: A unique integer that specifies this product
        :type unique_id: int
        :param display_name: The name of the product to use when displaying to the user
        :type display_name: str
        :param app_type: The application this product represents
        :type app_type: str
        :param version: The version of the application
        :type version: str
        """

        self._unique_id = unique_id
        self._display_name = display_name
        self._app_type = app_type
        self._version = version

    def get_unique_id(self):
        return self._unique_id

    def get_app_type(self):
        return self._app_type

    def get_display_name(self):
        return self._display_name

    def get_version(self):
        return self._version
