__all__ = 'RemoteProject'

from abc import abstractmethod

from .project import Project


class RemoteProject(Project):

    def __init__(self,
                 name,
                 root_dir,
                 files,
                 attributes):
        Project.__init__(self,
                         name,
                         root_dir,
                         files,
                         attributes)

    @abstractmethod
    def get_files(self, force_update=False):
        raise NotImplementedError

    @abstractmethod
    def set_file_list(self, files):
        raise NotImplementedError

    @abstractmethod
    def set_name(self, name):
        raise NotImplementedError

    @abstractmethod
    def exists(self):
        raise NotImplementedError

    @abstractmethod
    def delete(self):
        raise NotImplementedError

    @abstractmethod
    def get_size(self):
        raise NotImplementedError

    @abstractmethod
    def set_size(self, size):
        raise NotImplementedError

    @abstractmethod
    def get_total_bytes_done_uploading(self, force_update=False):
        raise NotImplementedError

    @abstractmethod
    def set_total_bytes_done_uploading(self, bytes):
        raise NotImplementedError

    @abstractmethod
    def get_remaining_bytes_to_upload(self, force_update=False):
        raise NotImplementedError
