__all__ = 'CheckBox'

from .input_widget import InputWidget
from PySide2 import QtWidgets
from PySide2 import QtCore


class CheckBox(QtWidgets.QCheckBox, InputWidget):

    def __init__(self, plugin, parent=None):
        QtWidgets.QCheckBox.__init__(self, parent=parent)
        InputWidget.__init__(self, plugin)

        self.setFocusPolicy(QtCore.Qt.StrongFocus)
        self.stateChanged.connect(self._catch_value_change)

    def get_value(self):
        return self.checkState() == QtCore.Qt.Checked

    def set_value(self, value):
        if value:
            self.setCheckState(QtCore.Qt.Checked)
        else:
            self.setCheckState(QtCore.Qt.Unchecked)