__all__ = 'LineEdit'

from .input_widget import InputWidget
from PySide2 import QtWidgets


class LineEdit(QtWidgets.QLineEdit, InputWidget):

    def __init__(self, plugin, parent=None):
        QtWidgets.QLineEdit.__init__(self, parent=parent)
        InputWidget.__init__(self, plugin)

        self.editingFinished.connect(self._catch_value_change)
        self.textChanged.connect(self.recalculate_styles)

    def recalculate_styles(self):
        # required to update the style sheet for the placeholder text style
        self.style().unpolish(self)
        self.style().polish(self)

    def get_value(self):
        return self.text()

    def set_value(self, value):
        self.setText(value)