__all__ = 'ListInput'

from .input_widget import InputWidget
from PySide2 import QtWidgets
from PySide2 import QtCore
from gm_qt_plugin import qt_constants
from gm_qt_plugin.widgets.input_widgets.spin_box import SpinBox
from gm_qt_plugin.widgets.input_widgets.check_box import CheckBox
from gm_qt_plugin.widgets.elided_label import ElidedLabel


class ListInput(QtWidgets.QWidget, InputWidget):

    def __init__(self, plugin, parent=None):
        QtWidgets.QWidget.__init__(self, parent=parent)
        InputWidget.__init__(self, plugin)

        """ Create Widgets """
        self.group_box = QtWidgets.QGroupBox()
        self.group_box.setProperty("background-level-2", True)

        self._add_item_btn = QtWidgets.QPushButton(u"+")
        self._add_item_btn.setFlat(True)
        self._add_item_btn.setProperty(qt_constants.STYLE_PROPS.BORDERED, True)

        self._remove_item_btn = QtWidgets.QPushButton(u"-")
        self._remove_item_btn.setFlat(True)
        self._remove_item_btn.setProperty(qt_constants.STYLE_PROPS.BORDERED, True)

        """ Create Layout """
        self._controls_layout = QtWidgets.QVBoxLayout()
        self._controls_layout.setContentsMargins(0, 0, 0, 0)
        self._controls_layout.setAlignment(QtCore.Qt.AlignTop)
        self._controls_layout.addWidget(self._add_item_btn)
        self._controls_layout.addWidget(self._remove_item_btn)

        self._items_layout = QtWidgets.QVBoxLayout()
        self._items_layout.setContentsMargins(0, 0, 0, 0)
        self._items_layout.setAlignment(QtCore.Qt.AlignTop)

        self.hlayout = QtWidgets.QHBoxLayout(self.group_box)
        self.hlayout.setContentsMargins(0, 0, 0, 0)
        self.hlayout.addLayout(self._items_layout)
        self.hlayout.addStretch()
        self.hlayout.addLayout(self._controls_layout)

        self.layout = QtWidgets.QVBoxLayout(self)
        self.layout.setContentsMargins(0, 0, 0, 0)
        self.layout.addWidget(self.group_box)

        """ Create Connections """

    def minimumSizeHint(self):
        return QtCore.QSize(0, 0)

    def get_value(self):
        return ""

    def set_value(self, value):
        pass
