__all__ = 'Notification'

from PySide2 import QtCore
from PySide2 import QtGui
from PySide2 import QtWidgets

from gm_qt_plugin.widgets.elided_label import ElidedLabel
from gm_qt_plugin import qt_constants


class Notification(QtWidgets.QGroupBox):

    def __init__(self, text, parent=None):
        QtWidgets.QGroupBox.__init__(self, parent=parent)

        self.autoFillBackground = True
        self.setProperty(qt_constants.STYLE_PROPS.NOTIFICATION_INFO, True)

        """ Create Widgets """
        self._label = ElidedLabel(text)
        self._label.setProperty(qt_constants.STYLE_PROPS.H4_5, True)
        self._close_btn = QtWidgets.QPushButton('X')
        self._close_btn.setFlat(True)
        self._close_btn.setSizePolicy(QtWidgets.QSizePolicy.Fixed, QtWidgets.QSizePolicy.Fixed)

        """ Create Layouts """
        self._layout = QtWidgets.QHBoxLayout(self)
        self._layout.addWidget(self._label)
        self._layout.addWidget(self._close_btn)

        """ Create Connections """
        self._close_btn.clicked.connect(self.hide)