__all__ = 'PackCurrentSceneWidget'

import pathlib

from PySide2 import QtCore
from PySide2 import QtWidgets

from gm_qt_plugin.qt_plugin_accessor import QtPluginAccessor


class PackCurrentSceneWidget(QtWidgets.QWidget, QtPluginAccessor):

    def __init__(self, plugin, parent=None):
        QtWidgets.QWidget.__init__(self, parent=parent)
        QtPluginAccessor.__init__(self, plugin)

        """ Create Widgets """
        self.group_box = QtWidgets.QGroupBox()
        self.group_box.setTitle("Pack Current Scene")

        self.description_label = QtWidgets.QLabel("Save the current scene to a local folder and then package all external assets into the project")
        self.description_label.setEnabled(False)

        self.export_path_label = QtWidgets.QLabel("Export Path")
        self.export_path_input = QtWidgets.QLineEdit()

        self.export_btn = QtWidgets.QPushButton("Pack current Scene")
        self.export_btn.clicked.connect(self.execute)

        """ Create Layouts """
        self.form_layout = QtWidgets.QFormLayout()
        self.form_layout.addRow(self.export_path_label, self.export_path_input)

        self.container_layout = QtWidgets.QVBoxLayout()
        self.container_layout.addWidget(self.description_label)
        self.container_layout.addLayout(self.form_layout)
        self.container_layout.addWidget(self.export_btn)

        self.group_box.setLayout(self.container_layout)

        self.layout = QtWidgets.QVBoxLayout(self)
        self.layout.setContentsMargins(0,0,0,0)
        self.layout.setAlignment(QtCore.Qt.AlignTop)

        self.layout.addWidget(self.group_box)

    def execute(self):
        plugin = self.get_plugin()
        user_interface = plugin.get_user_interface()
        logging_coordinator = plugin.get_logging_coordinator()
        logger = logging_coordinator.get_logger(__name__)

        export_path = pathlib.Path(self.export_path_input.text())

        logger.info(u"Pack current scene to '" + unicode(export_path) + u"'")

        ################################################################################################################

        raise NotImplementedError()
        #MayaSceneExporter().export(export_path)

        """
        args = (
            export_path,
        )

        kwargs = {}

        running_operation_message = "Packing project..."

        return self.boilerplate_execute(context, method, args, kwargs, running_operation_message)
        """