__all__ = 'PushButton'

from PySide2 import QtCore, QtWidgets


class PushButton(QtWidgets.QPushButton):

    def __init__(self, text, parent=None):
        QtWidgets.QPushButton.__init__(self, parent=parent)

        self.setText(text)
        self.setFocusPolicy(QtCore.Qt.StrongFocus)
        self.setCursor(QtCore.Qt.PointingHandCursor)

    def mousePressEvent(self, event):

        # In PySide2-5.15.2 buttons don't register clicks on the edges when padding is set. This gets around that issue.
        if self.underMouse() and not self.hitButton(event.pos()):
            self.clicked.emit()

        QtWidgets.QPushButton.mousePressEvent(self, event)