__all__ = 'Logger'

import gm_meta_plugin
import typing

if typing.TYPE_CHECKING:
    from .logging_coordinator import LoggingCoordinator


class Logger(gm_meta_plugin.Logger):

    def __init__(self, name: str, logging_coordinator: 'LoggingCoordinator'):
        gm_meta_plugin.Logger.__init__(self, name, logging_coordinator)

    def debug(self, msg, *args, **kwargs) -> None:
        self._log(msg, "DEBUG")
        self._logger.debug(msg, *args, **kwargs)

    def info(self, msg, *args, **kwargs) -> None:
        self._log(msg, "INFO")
        self._logger.info(msg, *args, **kwargs)

    def warning(self, msg, *args, **kwargs) -> None:
        self._log(msg, "WARNING")
        self._logger.warning(msg, *args, **kwargs)

    def error(self, msg, *args, **kwargs) -> None:
        self._log(msg, "ERROR")
        self._logger.error(msg, *args, **kwargs)

    def exception(self, msg, *args, **kwargs) -> None:
        self._log(msg, "ERROR")
        self._logger.exception(msg, *args, exc_info=True, **kwargs)

    def critical(self, msg, *args, **kwargs) -> None:
        self._log(msg, "ERROR")
        self._logger.critical(msg, *args, **kwargs)