
class MayaRenderer:
    def __init__(self, commandline_name, internal_name):
        self._commandline_name = commandline_name
        self._internal_name = internal_name

    def get_commandline_name(self):
        return self._commandline_name

    def get_internal_name(self):
        return self._internal_name


class RENDERERS:
    MAYA_SOFTWARE_RENDERER = MayaRenderer('sw', 'mayaSoftware')
    MAYA_HARDWARE_RENDERER = MayaRenderer('hw', 'mayaHardware')
    MAYA_HARDWARE_2_RENDERER = MayaRenderer('hw2', 'mayaHardware2')
    MAYA_VECTOR_RENDERER = MayaRenderer('vr', 'mayaVector')
    MAYA_ARNOLD_RENDERER = MayaRenderer('arnold', 'arnold')
    MAYA_RENDERMAN_RENDERER = MayaRenderer('rman', 'rman')
    MAYA_REDSHIFT_RENDERER = MayaRenderer('redshift', 'redshift')
    MAYA_VRAY_RENDERER = MayaRenderer('vray', 'vray')

IMAGE_FORMATS = {
    6:  ('als', 'Alias PIX (als)'),
    23: ('avi', 'AVI (avi)'),
    35: ('dds', 'DDS (dds)'),
    9:  ('eps', 'EPS (eps)'),
    0:  ('gif', 'GIF (gif)'),
    8:  ('jpg', 'JPEG (jpg)'),
    7:  ('iff', 'Maya IFF (iff)'),
    10: ('iff', 'Maya16 IFF (iff)'),
    31: ('psd', 'PSD (psd)'),
    36: ('psd', 'PSD Layered (psd)'),
    32: ('png', 'PNG (png)'),
    12: ('yuv', 'Quantel (yuv)'),
    22: ('mov', 'Quicktime Movie (mov)'),
    2:  ('rla', 'RLA (rla)'),
    5:  ('sgi', 'SGI (sgi)'),
    13: ('sgi', 'SGI16 (sgi)'),
    1:  ('pic', 'SoftImage (pic)'),
    19: ('tga', 'Targa (tga)'),
    3:  ('tif', 'Tiff (tif)'),
    4:  ('tif', 'Tiff16 (tif)'),
    20: ('bmp', 'Windows Bitmap (bmp)'),
    40: ('exr', 'EXR (exr)'),
    60: ('swf', 'Macromedia SWF (swf)'),
    61: ('ai',  'Adobe(R) Illustrator(R) (ai)'),
    62: ('svg', 'SVG (svg)'),

    # Multiple image formats map to code 63 so just default to png as a fall back
    63: ('png', 'PNG (png)'),
    # 63: ('tim', 'Sony Playstation (tim)'),
    # 63: ('xpm', 'XPM (xpm)'),
    # 63: ('swtf', 'Swift3DImporter (swft)'),
}

REDSHIFT_IMAGE_FORMATS = {
    0: ('iff', 'Maya IFF (iff)'),
    1: ('exr', 'OpenEXR (exr)'),
    5: ('tif', 'TIFF (tif)'),
    2: ('png', 'PNG (png)'),
    3: ('tga', 'Targa (tga)'),
    4: ('jpg', 'JPEG (jpg)'),
}


VRAY_IMAGE_FORMATS = {
    'png':                  'png',
    'jpg':                  'jpg',
    'vrimg':                'vrimg',
    'exr':                  'exr',
    'exr (multichannel)':   'exr',
    'exr (deep)':           'exr',
    'tga':                  'tga',
    'bmp':                  'bmp',
    'sgi':                  'sgi',
    'tif':                  'tif',
    'vrst':                 'vrst',
}



UNSUPPORTED_RENDERER = 'Unsupported Renderer'

VRAY_OUTPUT_DIR_NAME = 'gm_vray_standalone_files'
