__all__ = 'VrayJobPresetValidator'

import typing

from gm_meta_plugin.gridmarkets import constants as api_constants
from gm_meta_plugin import JobPresetValidator


class VrayJobPresetValidator(JobPresetValidator):

    def validate(self, job_preset) -> typing.Tuple[bool, str]:
        is_valid = True
        validation_message = u""

        output_prefix = job_preset.get_job_preset_attribute_by_key(api_constants.API_KEYS.OUTPUT_PREFIX).eval()
        if not output_prefix:
            return False, "No output prefix set, you must provide an output prefix when using V-Ray standalone."

        return is_valid, validation_message
