__all__ = 'WorkerJob'

import typing


class WorkerJob:
    def __init__(self, argv: typing.List[any]):
        self._argv = argv
        self._is_completed = False
        self._response = None

    def get_argv(self) -> typing.List[any]:
        return self._argv

    def is_completed(self) -> bool:
        return self._is_completed

    def mark_as_complete(self) -> None:
        self._is_completed = True

    def set_response(self, response: str) -> None:
        self._response = response

    def get_response(self) -> str:
        return self._response
